<?xml version='1.0'?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:fo="http://www.w3.org/1999/XSL/Format"
                xmlns:doc="http://nwalsh.com/xsl/documentation/1.0"
                exclude-result-prefixes="doc"
                version='1.0'>

<!-- It is important to use indent="no" here, otherwise verbatim -->
<!-- environments get broken by indented tags...at least when the -->
<!-- callout extension is used...at least with some processors -->
<xsl:output method="xml" indent="no"/>

<!-- ********************************************************************
     $Id: docbook.xsl,v 1.29 2003/09/07 19:07:35 nwalsh Exp $
     ********************************************************************

     This file is part of the XSL DocBook Stylesheet distribution.
     See ../README or http://nwalsh.com/docbook/xsl/ for copyright
     and other information.

     ******************************************************************** -->

<!-- ==================================================================== -->

<xsl:include href="F:\dea\Fop\Dookbook\fo\../VERSION"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\param.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\../lib/lib.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\../common/l10n.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\../common/common.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\../common/labels.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\../common/titles.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\../common/subtitles.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\../common/gentext.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\../common/pi.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\autotoc.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\autoidx.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\lists.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\callout.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\verbatim.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\graphics.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\xref.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\formal.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\table.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\htmltbl.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\sections.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\inline.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\footnote.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\fo.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\fo-rtf.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\info.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\keywords.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\division.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\index.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\toc.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\refentry.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\math.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\admon.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\component.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\biblio.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\glossary.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\block.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\task.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\qandaset.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\synop.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\titlepage.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\titlepage.templates.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\pagesetup.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\pi.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\ebnf.xsl"/>

<xsl:include href="F:\dea\Fop\Dookbook\fo\fop.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\passivetex.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\xep.xsl"/>
<xsl:include href="F:\dea\Fop\Dookbook\fo\axf.xsl"/>

<xsl:param name="stylesheet.result.type" select="'fo'"/>

<!-- ==================================================================== -->

<xsl:key name="id" match="*" use="@id"/>

<!-- ==================================================================== -->

<xsl:template match="*">
  <xsl:message>
    <xsl:value-of select="name(.)"/>
    <xsl:text> encountered</xsl:text>
    <xsl:if test="parent::*">
      <xsl:text> in </xsl:text>
      <xsl:value-of select="name(parent::*)"/>
    </xsl:if>
    <xsl:text>, but no template matches.</xsl:text>
  </xsl:message>
  <fo:block color="red">
    <xsl:text>&lt;</xsl:text>
    <xsl:value-of select="name(.)"/>
    <xsl:text>&gt;</xsl:text>
    <xsl:apply-templates/> 
    <xsl:text>&lt;/</xsl:text>
    <xsl:value-of select="name(.)"/>
    <xsl:text>&gt;</xsl:text>
  </fo:block>
</xsl:template>

<!-- Update this list if new root elements supported -->
<xsl:variable name="root.elements" select="' appendix article bibliography book chapter colophon dedication glossary index part preface refentry reference sect1 section set setindex '"/>

<xsl:template match="/">
  <xsl:variable name="document.element" select="*[1]"/>

  <xsl:if test="not(contains( $root.elements, concat(' ', local-name($document.element), ' ')))">
      <xsl:message terminate="yes">
ERROR: Document root element for FO output 
must be one of the following elements:
  <xsl:value-of select="$root.elements"/>
      </xsl:message>
  </xsl:if>

  <xsl:call-template name="root.messages"/>

  <xsl:variable name="title">
    <xsl:choose>
      <xsl:when test="$document.element/title[1]">
        <xsl:value-of select="$document.element/title[1]"/>
      </xsl:when>
      <xsl:otherwise>[could not find document title]</xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <fo:root xsl:use-attribute-sets="root.properties">
    <xsl:attribute name="language">
      <xsl:call-template name="l10n.language">
        <xsl:with-param name="target" select="/*[1]"/>
      </xsl:call-template>
    </xsl:attribute>

    <xsl:if test="$xep.extensions != 0">
      <xsl:call-template name="xep-document-information"/>
    </xsl:if>
    <xsl:if test="$axf.extensions != 0">
      <xsl:call-template name="axf-document-information"/>
    </xsl:if>
    <xsl:call-template name="setup.pagemasters"/>
    <xsl:choose>
      <xsl:when test="$rootid != ''">
        <xsl:choose>
          <xsl:when test="count(key('id',$rootid)) = 0">
            <xsl:message terminate="yes">
              <xsl:text>ID '</xsl:text>
              <xsl:value-of select="$rootid"/>
              <xsl:text>' not found in document.</xsl:text>
            </xsl:message>
          </xsl:when>
          <xsl:otherwise>
            <xsl:if test="$fop.extensions != 0">
              <xsl:apply-templates select="key('id',$rootid)" mode="fop.outline"/>
            </xsl:if>
            <xsl:if test="$xep.extensions != 0">
              <xsl:variable name="bookmarks">
                <xsl:apply-templates select="key('id',$rootid)" mode="xep.outline"/>
              </xsl:variable>
              <xsl:if test="string($bookmarks) != ''">
                <rx:outline xmlns:rx="http://www.renderx.com/XSL/Extensions">
                  <xsl:copy-of select="$bookmarks"/>
                </rx:outline>
              </xsl:if>
            </xsl:if>
            <xsl:apply-templates select="key('id',$rootid)"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <xsl:if test="$fop.extensions != 0">
          <xsl:apply-templates mode="fop.outline"/>
        </xsl:if>
        <xsl:if test="$xep.extensions != 0">
          <xsl:variable name="bookmarks">
            <xsl:apply-templates mode="xep.outline"/>
          </xsl:variable>
          <xsl:if test="string($bookmarks) != ''">
            <rx:outline xmlns:rx="http://www.renderx.com/XSL/Extensions">
              <xsl:copy-of select="$bookmarks"/>
            </rx:outline>
          </xsl:if>
        </xsl:if>
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>

  </fo:root>
</xsl:template>


<xsl:template name="root.messages">
  <!-- redefine this any way you'd like to output messages -->
  <!-- DO NOT OUTPUT ANYTHING FROM THIS TEMPLATE -->
  <xsl:message>
    <xsl:text>Making </xsl:text>
    <xsl:value-of select="$page.orientation"/>
    <xsl:text> pages on </xsl:text>
    <xsl:value-of select="$paper.type"/>
    <xsl:text> paper (</xsl:text>
    <xsl:value-of select="$page.width"/>
    <xsl:text>x</xsl:text>
    <xsl:value-of select="$page.height"/>
    <xsl:text>)</xsl:text>
  </xsl:message>
</xsl:template>

<!-- ==================================================================== -->

</xsl:stylesheet>
